<script setup lang="ts">
import { type User } from '@/types/User'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import UserCard from './UserCard.vue'
import { useUserStore } from '@/stores/user'

const props = defineProps<{
  users: User[]
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

function selected(p: User) {
  emit('selectedUser', p)
}

const userStore = useUserStore()

const dialog = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  closeDialog()
  // refreshPage()
}

function refreshPage() {
  window.location.reload()
}

onMounted(async () => {
  await userStore.getUsers()
})
</script>
<template>
  <div style="position: relative; overflow-y: auto">
    <v-toolbar flat style="background-color: #212121; color: white">
      <v-toolbar-title>Employee</v-toolbar-title>
    </v-toolbar>

    <v-dialog v-model="dialog" persistent width="1024">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" color="#c7a17a" class="new-user-btn"> New User </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">User</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.email"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Email"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.fullName"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Full Name"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.username"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Username"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.password"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Password"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="userStore.editedUser.gender"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Male', value: 'male' },
                      { title: 'Female', value: 'female' },
                      { title: 'Others', value: 'others' }
                    ]"
                    label="Gender"
                    :return-object="false"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="userStore.editedUser.role"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'User', value: 'User' },
                      { title: 'Admin', value: 'Admin' }
                    ]"
                    label="Role"
                    :return-object="false"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-file-input
                    v-model="userStore.editedUser.files"
                    :rules="[
                      (value) => {
                        return (
                          !value ||
                          !value.length ||
                          value[0].size < 5000000 ||
                          'Avatar size should be less than 5 MB!'
                        )
                      }
                    ]"
                    accept="image/png, image/jpeg"
                    label="Avatar"
                    placeholder="Pick an avatar"
                    prepend-icon="mdi-camera"
                  ></v-file-input>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-img
                    :src="'http://localhost:3000/images/users/' + userStore.editedUser.image"
                    width="100"
                  ></v-img>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small style="color: red">*Please fill data</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
          <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-container>
      <v-row>
        <v-col cols="12" md="3" v-for="item of users" :key="item.id">
          <UserCard :user="item" @selected-user="selected"></UserCard>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<style scoped>
.new-user-btn {
  position: relative;
  margin-top: 1%;
  left: 90%;
  margin-bottom: 20px;
}
</style>
